<template>
  <basic-container>
    <avue-crud
      :option="option"
      :table-loading="loading"
      :data="data"
      :page.sync="page"
      ref="crud"
      @search-change="searchChange"
      @current-change="currentChange"
      @size-change="sizeChange"
      @refresh-change="refreshChange"
      @search-reset="searchReset"
      @on-load="onLoad"
    >
      <template slot-scope="{ row }" slot="menu">
        <el-button
          type="text"
          size="small"
          @click.stop="updateRow(row)"
        ><i class="el-icon-share"></i>处理
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
import {dateFormat} from '@/util/date'
import Tinymce from "@/components/Tinymce";
import {getList, getInfo, updateSuperviseComplaintInfo} from '@/api/manage/superviseComplaintInfo'

const initPages = {
  pageSize: 10,
  currentPage: 1,
  total: 100,
}
const classEnum = {
  1: '一般投诉',
  2: '较难投诉',
  3: '困难投诉',
  4: '特殊投诉',
}
const classIsDeleted = {
  0: '否',
  1: '是',
}
const classStatus = {
  0: '未处理',
  1: '已处理',
  2: '关闭'
}
const classEnumList = Object.keys(classEnum).map((item) => ({
  label: classEnum[item], value: Number(item)
}))
const classEnumDeleted = Object.keys(classIsDeleted).map((item) => ({
  label: classIsDeleted[item], value: Number(item)
}))
const classEnumStatus = Object.keys(classStatus).map((item) => ({
  label: classStatus[item], value: Number(item)
}))
const columnList = [
  {
    label: "投诉标题",
    prop: "complaintTitle",
    search: true
  },
  {
    label: "投诉对象",
    prop: "complaintObject",
    search: true
  },
  {
    label: "联系方式",
    prop: "complaintPhone",
    search: true
  },
  {
    label: "投诉类型",
    prop: "complaintType",
    type: "select",
    dataType: "number",
    dicData: classEnumList,
    display: false,
    search: true
  },
  {
    label: "是否处理",
    prop: "status",
    type: "select",
    dicData: classEnumStatus,
    search: true,
  },
  {
    label: "处置情况",
    prop: "disposalSituation",
    search: true,
  },
  {
    label: "创建时间",
    prop: "complaintTime",
    type: 'datetime',
    searchSpan: 8,
    searchRange: true,
  }
]
const rules = {
  name: [
    {required: true, message: '请输入内容标题', trigger: 'blur'}
  ],
  type: [
    {required: true, message: '请选择分类', trigger: 'blur'}
  ],
  content: [
    {required: true, message: '请输入内容', trigger: 'blur'}
  ],
}
export default {
  name: "index",
  components: {
    Tinymce
  },
  created() {
    // this.seeDetail({id: '1783485236359442433'})
  },
  data() {
    return {
      applTime: '',
      loading: false,
      viewDrawer: false,
      drawerTitle: '新增内容',
      formOption: {},
      query: {},
      rules: Object.assign({}, rules),
      data: [],
      lookData: {},
      classEnum,
      page: Object.assign({}, initPages),
    }
  },
  computed: {
    option() {
      return {
        height: "auto",
        tip: false,
        searchShow: true,
        searchMenuSpan: 6,
        border: true,
        index: true,
        indexLabel: "序号",
        selection: false,
        viewBtn: true,
        addBtn: false,
        editBtn: false,
        delBtn: false,
        columnBtn: false,
        menuWidth: 140,
        labelWidth: 151,
        dialogClickModal: false,
        dialogType: "drawer",
        dialogFullscreen: true,
        column: columnList,
      }
    }
  },
  methods: {
    dateFormat,
    updateRow(row) {
      const _this = this
      let h = this.$createElement;
      this.$prompt("回复处理", // "请核对信息后",
        {
          distinguishCancelAndClose: true,
          confirmButtonText: "完 成",
          cancelButtonText: "取 消",
          center: true,
          inputType: "textarea",
          inputPlaceholder: "处理内容",
          beforeClose: async function (action, instance, done) {
            if (action === 'confirm') {
              const disposalSituation = instance.inputValue
              if (!disposalSituation) {
                this.$message({type: "info", message: "请输入处理内容"});
              } else {
                let resData = await updateSuperviseComplaintInfo({id: row.id, disposalSituation, status: 1})
                if (resData.data.code === 200) {
                  this.$message({type: "success", message: "操作成功"});
                  done()
                  _this.onLoad();
                }
              }
            } else {
              done()
            }
          }
        }
      )
    },
    resetForm(formName) {
      this.$refs[formName].resetFields();
      this.viewDrawer = false
    },
    searchReset() {
      this.query = {};
      this.onLoad();
    },
    searchChange(params, done) {
      console.log(params);
      if (params.applTime) {
        var val = JSON.parse(JSON.stringify(params.applTime))
        params.applTimeStart = val[0] + " 00:00:00";
        params.applTimeEnd = val[1] + " 23:59:59";
        delete params.applTime
      }
      this.query = params;
      console.log(this.query);
      this.page.currentPage = 1;
      this.onLoad();
      done();
    },
    currentChange(val) {
      this.page.currentPage = val
    },
    sizeChange(val) {
      this.page.currentPage = 1
      this.page.pageSize = val
    },
    refreshChange() {
      this.page.currentPage = 1;
      this.onLoad()
    },
    /* 表格方法 */
    onLoad() {
      return new Promise(async (resolve, reject) => {
        this.loading = true;
        let params = {
          current: this.page.currentPage,
          size: this.page.pageSize,
          ...this.query,
        }
        let resData = await getList(params)
        if (resData.data.code === 200) {
          const {current, records, total, size} = resData.data.data
          this.data = records;
          this.page.total = total;
          this.loading = false;
        }
        resolve()
      })
    },
    seeDetail(row) {
      return new Promise(async (resolve, reject) => {
        let params = {
          id: row.id
        }
        let resData = await getInfo(params)
        if (resData.data.code === 200) {
          this.drawerTitle = '查看'
          this.lookData = JSON.parse(JSON.stringify(resData.data.data))
          this.formOption = JSON.parse(JSON.stringify(resData.data.data))
          this.viewDrawer = true
        }
      })
    }
  }
}
</script>

<style scoped>

</style>
